//
// Created by auric on 2/21/24.
//

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <nprint.h>
#include <stdbool.h>
#include <sanity.h>
#include "config.h"
#include "debug.h"


void help() {
    nprint("E", "Usage: fex (OPT) (PACKAGES)");
}

int main(int argc, char** argv) {
    int fIns = 0, fUpd = 0, fSrc = 0, fUin = 0, fLis = 0, fSer = 0, fVer = 0, fFrc = 0, fUpg = 0;
    char* packages[argc - 1];
    int pkgCount = 0;
    if (argc < 2) {
        help();
        return 1;
    }



    for(int i = 1; i < argc; i++) {
        if(argv[i][0] == '-') {
            for(int j = 1; argv[i][j] != '\0'; j++) {
                switch(argv[i][j]) {
                    case 'i': // install
                        fIns = 1;
                        break;
                    case 'u': // update
                        fUpd = 1;
                        break;
                    case 'S': // source
                        fSrc = 1;
                        break;
                    case 'r': // remove
                        fUin = 1;
                        break;
                    case 'l': // list
                        fLis = 1;
                        break;
                    case 's': // search
                        fSer = 1;
                        break;
                    case 'v': // verbose
                        fVer = 1;
                        break;
                    case 'f': // force
                        fFrc = 1;
                        break;
                    case 'c': // upgrade; don't ask why I'm using 'c'
                        fUpg = 1;
                        break;
                    default:
                        nprint("E", "Flag '%c' is unknown.", argv[i][j]);
                        return 1;
                }
            }
        } else {
            packages[pkgCount++] = argv[i];
        }
    }

    const int sysSanity = isSysSane();

    #ifdef debugEnabled
        DEBUG_PRINT("sysSanity: %d", sysSanity);
        const char* flagNames[] = {"Install", "Update", "Source", "Remove", "List", "Search","Verbose", "Force", "Upgrade"};
        int* flagValues[] = {&fIns, &fUpd, &fSrc, &fUin, &fLis, &fSer, &fVer, &fFrc, &fUpg};
        int flagCount = sizeof(flagNames) / sizeof(flagNames[0]); // This should match the number of flags

        for(int i = 0; i < flagCount; i++) {
            nprint("D", "Flag %s: %d", flagNames[i], *flagValues[i]);
        }
        for(int i = 0; i < pkgCount; i++) {
            nprint("D", "Package %d: %s", i, packages[i]);
        }
    #endif
    return 0;
}