#include <sys/stat.h>
#include "../inc/sanity.h"

/*
 * 0: success
 * 1: con failure
 * 2: exe failure
 * 3: con and exe failure
 * 4: uti failure
 * 5: uti and con failure
 * 6: uti and exe failure
 * 7: total failure
 */

int isSysSane() {
    struct stat conStat, exeStat, utiStat;
    int result = 0;

    if (stat("/con", &conStat) != 0 || !(conStat.st_mode & S_IWUSR)) {
        result |= SANITY_CON_FAIL;
    }

    if (stat("/exe", &exeStat) != 0 || !(exeStat.st_mode & S_IWUSR)) {
        result |= SANITY_EXE_FAIL;
    }

    if (stat("/uti", &utiStat) != 0 || !(utiStat.st_mode & S_IWUSR)) {
        result |= SANITY_UTI_FAIL;
    }

    return result;
}

